module Deriv.StrMat.ByteString.Lazy
    ( Str
    , Mat

    , group
    , groups
    , match
    , matchAndGroups
    , regexing

    , toUpper
    , loadFile
    ) where

import qualified Data.ByteString.Lazy as L (ByteString)
import qualified Data.ByteString.Lazy as L.Byt
import qualified Data.ByteString.Lazy.Char8 as L.Byt.Char8
import qualified Data.Char as Char
import           Optics.Core (IxTraversal', Getter)
import           Optics.Regex.ByteString.Lazy (Match)
import qualified Optics.Regex.ByteString.Lazy as Opt.L.Byt
import           Text.Regex.PCRE.Heavy (Regex)


type Str = L.ByteString
type Mat = Match

group :: Int -> IxTraversal' Str Mat Str
group = Opt.L.Byt.group

groups :: IxTraversal' Str Mat [Str]
groups = Opt.L.Byt.groups

match :: IxTraversal' [Str] Mat Str
match = Opt.L.Byt.match

matchAndGroups :: Getter Mat (Str, [Str])
matchAndGroups = Opt.L.Byt.matchAndGroups

regexing :: Regex -> IxTraversal' Int Str Mat
regexing = Opt.L.Byt.regexing

toUpper :: Str -> Str
toUpper = L.Byt.Char8.map Char.toUpper

loadFile :: String -> IO Str
loadFile = L.Byt.readFile
